

*f̊i[Ă;
data model;
  input model $80.;
  cards;
model{
for(j in 1:N){
y[j] ~ dnorm(mu[j], sigma2inv)
mu[j] <- theta[j]
}
for(k in 2:N){
theta[k]~dnorm(mu.theta[k], prec.theta[k])
mu.theta[k]<- theta[k-1] + delta[k-1]
delta[k]~dnorm(delta[k-1], prec.delta[k])
prec.theta[k]<- 1/(W * sigma * sigma)
prec.delta[k]<- 1/(W * sigma * sigma)
}
theta[1]~dnorm(0,1.0E-4)
delta[1]~dnorm(0, 1.0E-4)
beta ~ dnorm(0,1.0E-4)
sigma2inv ~ dgamma(0.1, 0.1)
sigma <- 1/sqrt(sigma2inv)
W ~ dunif(0.01,100)
}
;
run;

*f̕ۑ;
data _null_;
  set model;
  file "C:\WinBUGS\NDLMmodel.txt";
  put model;
run;

data _null_;
  file "C:\program files\WinBUGS14\NDLMBatch1.txt";
  put // @@
  #1  "display('log')"
  #2  "check('C:/WinBUGS\NDLMmodel.txt')"
  #3  "data('C:/WinBUGS\Data.txt')"
  #4  "compile(3)"
  #5  "gen.inits()"
  #6  "update(1000)"
  #7  "thin.updater(20)"
  #8  "set(mu)"
  #9  "set(W)"
  #10 "set(delta)"
  #11 "set(sigma2inv)"
  #12 "dic.set()"
  #13 "update(1000)"
  #14 "dic.stats()"
  #15 "coda(*,'C:/WinBUGS\MCMCout')"
  #16 "save('C:/WinBUGS\log.odc')"
  #17 "quit()"
  ;
run;
*ob`t@Cۑ;
data _null_;
  file "C:\WinBUGS\NDLM.bat";
  put  "CD C:\program files\WinBUGS14";
  put "WinBUGS14.exe /PAR NDLMBatch.txt";
  put "exit";
run;

%macro simulation(mc=);
  *V~[Vf[^;
  %do z=1 %to &mc;
    data data(keep=y);
      seed=&z; n=8;
      do i=1 to n;
        select(i);
          when(1) y=0 + rannor(seed);
          when(2) y=1 + rannor(seed);
          when(3) y=2 + rannor(seed);
          when(4) y=3 + rannor(seed);
          when(5) y=4 + rannor(seed);
          when(6) y=3 + rannor(seed);
          when(7) y=2 + rannor(seed);
          when(8) y=1 + rannor(seed);
          otherwise;
        end;
      	output;
      end;
    run;

    %dtrans(data=data, outfile=C:\WinBUGS\Data.txt, var=y);

    data  _null_;
      x "C:\WinBUGS\NDLM.bat";
    run;

    %codatrans(codapath=C:\WinBUGS, prefix=mcmcout, outcoda=coda, outstats=stat, outnums=3, outgraph=N);

    %if &z=1 %then %do;
      data allstat; delete; run;
    %end;
    data allstat;
      set allstat stat;
    run;
  %end;

  proc contents data=allstat(drop=parameter prm_grp prm_seq) out=_con noprint;
  run;
  proc sort data=_con; by varnum; run;
  proc sql noprint;
    select name into: varlist separated by ' '  from _con;
  quit;
  proc means data=allstat nway noprint;
    var &varlist;
    class parameter;
    output out=mcmean mean=&varlist; *f[^ZbgmcmeanɃV~[Vʂo;
  run;
%mend simulation;

*Simulations;
%simulation(mc=2);
