/*-----------------------------------------------------------------------                                                                                                                               
SAS Version : Ver.9.1.3  
 
data        : ̓f[^
var         : ͕ϐi̕ϐw\jjvar=x y z;
outfile     : WinBUGS荞ݗptxtt@CipX܂ށj
format      : ̓f[^̏o͗ptH[}bg
rounddigit  : ľܓ̌
ls          : w肵CTCYȓŃJ}Ƃɒl؂i50ȏw肷j
-----------------------------------------------------------------------*/

%macro dtrans(data=, var=, outfile=, format=best32, rounddigit=15, ls=50);
 
	%let i=0; *;
	%do %until(&&var&i=);
		%let i=%eval(&i+1);
		%let var&i=%scan(&var, &i, %str( )); *var&i:var̊eϐ;
	%end;
	%let varn=%eval(&i-1); *var:ϐ̌;

  *̓f[^̃IuUx[V擾;
  %let dsid = %sysfunc(open(&data));
  %let nobs = %sysfunc(attrn(&dsid, nobs)); 
  %let rc = %sysfunc(close(&dsid));
 
  *̓f[^̏o͗ptH[}bg;
  proc format;
    value varf
    ., .a - .z, ._ = "NA"
    other           = [ &format.. ]
    ;
  run;
 
  *̓f[^}NϐɊi[;
  data _null_;
    set &data;
    array _var(*) &var;
    do i=1 to dim(_var);
      if .z < _var(i) then _var(i)=round(_var(i), 10**(-&rounddigit));
      call symputx("val" || trim(put(i, best.-l)) || "_" || put(_n_, best.-l), put(_var(i), varf.));
    end;
  run;

  *WinBUGS荞ݗptxtt@Cۑ;
  data _null_;
    file "&outfile" ls=&ls;
    put "list(N=&nobs,";
    
    %do i=1 %to &varn;
      put "&&var&i = c(";
      %if 1 < &nobs %then %do;
        %do j=1 %to &nobs-1;
          put "&&val&i._&j," @;
        %end;
      %end;

      put "&&val&i._&nobs" ")" 

      %if &i = &varn %then %do; ")" %end; 
      %else %do; "," %end;
      ;
    %end;
  run;

%mend dtrans;
